var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.launchTizenSimulator=launchTizenSimulator;exports.configureTizenGlobal=exports.buildTizenProject=exports.runTizen=exports.addDevelopTizenCertificate=exports.createDevelopTizenCertificate=exports.configureTizenProject=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _inquirer=_interopRequireDefault(require("inquirer"));
var _net=_interopRequireDefault(require("net"));
var _xml2json=_interopRequireDefault(require("xml2json"));

var _exec=require("../../systemTools/exec");
var _constants=require("../../constants");
var _common=require("../../common");












var _projectParser=require("../../projectTools/projectParser");
var _fileutils=require("../../systemTools/fileutils");
var _web=require("../web");function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(source,true).forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(source).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}

var CHECK_INTEVAL=2000;

var formatXMLObject=function formatXMLObject(obj){return _objectSpread({},
obj['model-config'].platform.key.reduce(function(acc,cur,i){
acc[cur.name]=cur.$t;
return acc;
},{}));};


var configureTizenGlobal=function configureTizenGlobal(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('configureTizenGlobal');


var tizenAuthorCert=_path.default.join(c.paths.private.dir,'tizen_author.p12');
if(_fs.default.existsSync(tizenAuthorCert)){
console.log('tizen_author.p12 file exists!');
resolve();
}else{
console.log('tizen_author.p12 file missing! Creating one for you...');
createDevelopTizenCertificate(c).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}

});};exports.configureTizenGlobal=configureTizenGlobal;

function launchTizenSimulator(c,name){
(0,_common.logTask)("launchTizenSimulator:"+name);var
maxErrorLength=c.program.maxErrorLength;

if(name){
return(0,_exec.execCLI)(c,_constants.CLI_TIZEN_EMULATOR,"launch --name "+name,{detached:true,maxErrorLength:maxErrorLength});
}
return Promise.reject('No simulator -t target name specified!');
}

var createDevelopTizenCertificate=function createDevelopTizenCertificate(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('createDevelopTizenCertificate');var
maxErrorLength=c.program.maxErrorLength;

(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"certificate -- "+c.paths.private.dir+" -a rnv -f tizen_author -p 1234").
then(function(){return addDevelopTizenCertificate(c);}).
then(function(){return resolve();}).
catch(function(e){
(0,_common.logError)(e);
resolve();
});
});};exports.createDevelopTizenCertificate=createDevelopTizenCertificate;

var addDevelopTizenCertificate=function addDevelopTizenCertificate(c){return new Promise(function(resolve){
(0,_common.logTask)('addDevelopTizenCertificate');var
maxErrorLength=c.program.maxErrorLength;

(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"security-profiles add -n RNVanillaCert -a "+_path.default.join(c.paths.private.dir,'tizen_author.p12')+" -p 1234").
then(function(){return resolve();}).
catch(function(e){
(0,_common.logError)(e);
resolve();
});
});};exports.addDevelopTizenCertificate=addDevelopTizenCertificate;

var getDeviceID=function getDeviceID(c,target){var _c$program,device,maxErrorLength,connectResponse,devicesList,lines,devices,deviceID;return _regenerator.default.async(function getDeviceID$(_context){while(1){switch(_context.prev=_context.next){case 0:_c$program=
c.program,device=_c$program.device,maxErrorLength=_c$program.maxErrorLength;if(!

device){_context.next=7;break;}_context.next=4;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_SDB_TIZEN,"connect "+target));case 4:connectResponse=_context.sent;if(!
connectResponse.includes('failed to connect to remote target')){_context.next=7;break;}throw new Error(connectResponse);case 7:_context.next=9;return _regenerator.default.awrap(


(0,_exec.execCLI)(c,_constants.CLI_SDB_TIZEN,'devices'));case 9:devicesList=_context.sent;if(!
devicesList.includes(target)){_context.next=16;break;}
lines=devicesList.trim().split(/\r?\n/);
devices=lines.filter(function(line){return line.includes(target);});

if(devices.length>1){

}

deviceID=devices[0].split('device')[1].trim();return _context.abrupt("return",
deviceID);case 16:throw"No device matching "+

target+" could be found.";case 17:case"end":return _context.stop();}}});};


var getRunningDevices=function getRunningDevices(c){var _c$program2,platform,maxErrorLength,devicesList,lines,devices;return _regenerator.default.async(function getRunningDevices$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:_c$program2=
c.program,platform=_c$program2.platform,maxErrorLength=_c$program2.maxErrorLength;_context3.next=3;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_SDB_TIZEN,'devices'));case 3:devicesList=_context3.sent;
lines=devicesList.trim().split(/\r?\n/).filter(function(line){return!line.includes('List of devices');});
devices=[];_context3.next=8;return _regenerator.default.awrap(

Promise.all(lines.map(function _callee(line){var words,name,deviceInfoXML,deviceInfo,deviceType;return _regenerator.default.async(function _callee$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
words=line.replace(/\t/g,'').split('    ');if(!(
words.length>=3)){_context2.next=8;break;}
name=words[0].trim();_context2.next=5;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_SDB_TIZEN,"-s "+name+" shell cat /etc/config/model-config.xml",{ignoreErrors:true}));case 5:deviceInfoXML=_context2.sent;




if(deviceInfoXML!==true){

deviceInfo=formatXMLObject(_xml2json.default.toJson(deviceInfoXML,{object:true,reversible:false}));
deviceType=deviceInfo['tizen.org/feature/profile'];
}

if(platform==='tizenmobile'&&deviceType==='mobile'||platform==='tizenwatch'&&deviceType==='wearable'||platform==='tizen'&&!deviceType){
devices.push({
name:name,
type:words[1].trim(),
id:words[2].trim(),
deviceType:deviceType});

}case 8:case"end":return _context2.stop();}}});})));case 8:return _context3.abrupt("return",



devices);case 9:case"end":return _context3.stop();}}});};


var waitForEmulatorToBeReady=function waitForEmulatorToBeReady(c,target){return(0,_common.waitForEmulator)(c,_constants.CLI_SDB_TIZEN,'devices',function(res){
var lines=res.trim().split(/\r?\n/);
var devices=lines.filter(function(line){return line.includes(target)&&line.includes('device');});
return devices.length>0;
});};

var composeDevicesString=function composeDevicesString(devices){return devices.map(function(device){return{key:device.id,name:device.name,value:device.id};});};

var runTizen=function runTizen(c,platform,target){var platformConfig,_c$program3,hosted,maxErrorLength,isHosted,tDir,tBuild,tOut,tId,gwt,certProfile,deviceID,askForEmulator,continueLaunching,isTargetSpecified,devices,targetDevice,choices,_ref2,chosenEmulator;return _regenerator.default.async(function runTizen$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
(0,_common.logTask)("runTizen:"+platform+":"+target);

platformConfig=c.buildConfig.platforms[platform];_c$program3=
c.program,hosted=_c$program3.hosted,maxErrorLength=_c$program3.maxErrorLength;

isHosted=hosted||!(0,_common.getConfigProp)(c,platform,'bundleAssets');if(

platformConfig){_context6.next=6;break;}throw(
new Error("runTizen: "+_chalk.default.blue(platform)+" not defined in your "+_chalk.default.white(c.paths.appConfig.config)));case 6:if(

platformConfig.appName){_context6.next=8;break;}throw(
new Error("runTizen: "+_chalk.default.blue(platform)+".appName not defined in your "+_chalk.default.white(c.paths.appConfig.config)));case 8:


tDir=(0,_common.getAppFolder)(c,platform);
tBuild=_path.default.join(tDir,'build');
tOut=_path.default.join(tDir,'output');
tId=platformConfig.id;
gwt=platformConfig.appName+".wgt";
certProfile=platformConfig.certificateProfile;




askForEmulator=function askForEmulator(){var _ref,startEmulator,defaultTarget;return _regenerator.default.async(function askForEmulator$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:_context4.next=2;return _regenerator.default.awrap(
_inquirer.default.prompt([{
name:'startEmulator',
type:'confirm',
message:"Could not find or connect to the specified target ("+target+"). Would you like to start an emulator?"}]));case 2:_ref=_context4.sent;startEmulator=_ref.startEmulator;if(!


startEmulator){_context4.next=33;break;}
defaultTarget=c.files.private.config.defaultTargets[platform];_context4.prev=6;_context4.next=9;return _regenerator.default.awrap(

launchTizenSimulator(c,defaultTarget));case 9:
deviceID=defaultTarget;_context4.next=12;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,defaultTarget));case 12:return _context4.abrupt("return",
continueLaunching());case 15:_context4.prev=15;_context4.t0=_context4["catch"](6);

(0,_common.logDebug)("askForEmulator:ERRROR: "+_context4.t0);_context4.prev=18;_context4.next=21;return _regenerator.default.awrap(

(0,_exec.execCLI)(c,_constants.CLI_TIZEN_EMULATOR,"create -n "+defaultTarget+" -p tv-samsung-5.0-x86"));case 21:_context4.next=23;return _regenerator.default.awrap(
launchTizenSimulator(c,defaultTarget));case 23:
deviceID=defaultTarget;_context4.next=26;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,defaultTarget));case 26:return _context4.abrupt("return",
continueLaunching());case 29:_context4.prev=29;_context4.t1=_context4["catch"](18);

(0,_common.logDebug)(_context4.t1);
(0,_common.logError)("Could not find the specified target and could not create the emulator automatically. Please create one and then edit the default target from "+c.paths.private.dir+"/"+_constants.RENATIVE_CONFIG_NAME);case 33:case"end":return _context4.stop();}}},null,null,[[6,15],[18,29]]);};





continueLaunching=function continueLaunching(){var hasDevice,maxErrorLength,packageID,_packageID;return _regenerator.default.async(function continueLaunching$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
hasDevice=false;
maxErrorLength=c.program.maxErrorLength;_context5.t0=

!isHosted;if(!_context5.t0){_context5.next=6;break;}_context5.next=6;return _regenerator.default.awrap((0,_web.buildWeb)(c,platform));case 6:_context5.next=8;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild));case 8:_context5.next=10;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut));case 10:_context5.prev=10;


packageID=platform==='tizenwatch'||platform==='tizenmobile'?tId.split('.')[0]:tId;_context5.next=14;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"uninstall -p "+packageID+" -t "+deviceID,{ignoreErrors:true}));case 14:
hasDevice=true;_context5.next=25;break;case 17:_context5.prev=17;_context5.t1=_context5["catch"](10);if(!(

_context5.t1&&_context5.t1.includes&&_context5.t1.includes('No device matching'))){_context5.next=25;break;}_context5.next=22;return _regenerator.default.awrap(
launchTizenSimulator(c,target));case 22:_context5.next=24;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,target));case 24:hasDevice=_context5.sent;case 25:_context5.prev=25;_context5.next=28;return _regenerator.default.awrap(



(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"install -- "+tOut+" -n "+gwt+" -t "+deviceID));case 28:
hasDevice=true;_context5.next=40;break;case 31:_context5.prev=31;_context5.t2=_context5["catch"](25);

(0,_common.logError)(_context5.t2);
(0,_common.logWarning)("Looks like there is no emulator or device connected! Let's try to launch it. \""+
_chalk.default.white.bold("rnv target launch -p "+
platform+" -t "+target)+"\"");_context5.next=37;return _regenerator.default.awrap(



launchTizenSimulator(c,target));case 37:_context5.next=39;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,target));case 39:hasDevice=_context5.sent;case 40:if(!(


platform!=='tizenwatch'&&platform!=='tizenmobile'&&hasDevice)){_context5.next=45;break;}_context5.next=43;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"run -p "+tId+" -t "+deviceID));case 43:_context5.next=49;break;case 45:if(!(
(platform==='tizenwatch'||platform==='tizenmobile')&&hasDevice)){_context5.next=49;break;}
_packageID=tId.split('.');_context5.next=49;return _regenerator.default.awrap(
(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"run -p "+_packageID[0]+" -t "+deviceID));case 49:return _context5.abrupt("return",

true);case 50:case"end":return _context5.stop();}}},null,null,[[10,17],[25,31]]);};



isTargetSpecified=c.program.target;_context6.next=19;return _regenerator.default.awrap(


getRunningDevices(c));case 19:devices=_context6.sent;if(!

isTargetSpecified){_context6.next=45;break;}if(!

_net.default.isIP(target)){_context6.next=26;break;}_context6.next=24;return _regenerator.default.awrap(
getDeviceID(c,target));case 24:deviceID=_context6.sent;return _context6.abrupt("return",
continueLaunching());case 26:if(!(


devices.length>0)){_context6.next=31;break;}
targetDevice=devices.find(function(device){return device.id===target||device.name===target;});if(!
targetDevice){_context6.next=31;break;}
deviceID=targetDevice.id;return _context6.abrupt("return",
continueLaunching());case 31:_context6.prev=31;_context6.next=34;return _regenerator.default.awrap(




launchTizenSimulator(c,target));case 34:_context6.next=36;return _regenerator.default.awrap(
waitForEmulatorToBeReady(c,target));case 36:
deviceID=target;return _context6.abrupt("return",
continueLaunching());case 40:_context6.prev=40;_context6.t0=_context6["catch"](31);return _context6.abrupt("return",

askForEmulator());case 43:_context6.next=57;break;case 45:if(!(


devices.length===1)){_context6.next=48;break;}
deviceID=devices[0].id;return _context6.abrupt("return",
continueLaunching());case 48:if(!(
devices.length>1)){_context6.next=56;break;}
choices=composeDevicesString(devices);_context6.next=52;return _regenerator.default.awrap(
_inquirer.default.prompt([{
name:'chosenEmulator',
type:'list',
message:'On what emulator would you like to run the app?',
choices:choices}]));case 52:_ref2=_context6.sent;chosenEmulator=_ref2.chosenEmulator;

deviceID=chosenEmulator;return _context6.abrupt("return",
continueLaunching());case 56:return _context6.abrupt("return",

askForEmulator());case 57:case"end":return _context6.stop();}}},null,null,[[31,40]]);};exports.runTizen=runTizen;



var buildTizenProject=function buildTizenProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("buildTizenProject:"+platform);

var platformConfig=c.buildConfig.platforms[platform];
var tDir=(0,_common.getAppFolder)(c,platform);var
maxErrorLength=c.program.maxErrorLength;
var tOut=_path.default.join(tDir,'output');
var tBuild=_path.default.join(tDir,'build');
var certProfile=platformConfig.certificateProfile;

(0,_web.buildWeb)(c,platform).
then(function(){return(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild);}).
then(function(){return(0,_exec.execCLI)(c,_constants.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut);}).
then(function(){
(0,_common.logSuccess)("Your GWT package is located in "+_chalk.default.white(tOut)+" .");
return resolve();
}).
catch(function(e){return reject(e);});
});};exports.buildTizenProject=buildTizenProject;

var configureTizenProject=function configureTizenProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)('configureTizenProject');

if(!(0,_common.isPlatformActive)(c,platform,resolve))return;

(0,_projectParser.copyAssetsFolder)(c,platform).
then(function(){return(0,_projectParser.copyBuildsFolder)(c,platform);}).
then(function(){return configureProject(c,platform);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.configureTizenProject=configureTizenProject;

var configureProject=function configureProject(c,platform){return new Promise(function(resolve){
(0,_common.logTask)("configureProject:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);

var configFile='config.xml';
var p=c.buildConfig.platforms[platform];
(0,_common.writeCleanFile)(_path.default.join((0,_common.getAppTemplateFolder)(c,platform),configFile),_path.default.join(appFolder,configFile),[
{pattern:'{{PACKAGE}}',override:p.package},
{pattern:'{{ID}}',override:p.id},
{pattern:'{{APP_NAME}}',override:p.appName}]);


resolve();
});};